<?php
    require_once('class.AbstractLogEntry.php');

    class Logger
    {
        public $enabled = true;
        private $log;

        /**
         * @return Logger
         */
        static function& instance()
        {
            static $self = null;

            if (true == is_null($self)) {
                $self = new Logger();
            }

            return $self;
        }


        static function getTime()
        {
            $mtime = explode(' ', microtime());
            return (float)$mtime[1] + (float)$mtime[0];
        }

        public function __construct()
        {
            $this->log = array();
        }

        /**
        * @param AbstractLogEntry $record
        */
        public function addToLog($record)
        {
            if (true == $this->enabled && true == $record instanceof AbstractLogEntry) {
                $this->log[] = $record;
            }
        }

        public function clearLog()
        {
            $this->log = array();
        }

        public function dump($save = false)
        {
            $tt  = 0;
            $cnt = count($this->log);
            if (0 == $cnt) {
                return '';
            }

            ob_start();
            $entry = $this->log[0];

            print <<< delimiter
<table cellpadding='2' class='sqldebug'><thead>
delimiter;
            $entry->renderHeader();
            print <<< delimiter
</thead><tbody style="vertical-align: top">
delimiter;

            foreach ($this->log as $no => $entry)
            {
                $tt += $entry->time;
                $entry->render($no+1);
            }

            $tt = round($tt, 5);

            print <<< delimiter
    <tr>
        <td colspan='4' style='font-weight: bold'>Total $cnt queries, time taken:</td>
        <td>$tt</td>
    </tr>
</tbody>
</table>
delimiter;

            if (true == $save) {
                $s = ob_get_contents();
                ob_end_clean();
                return $s;
            }
            else {
                ob_end_flush();
                return '';
            }
        }
    }
?>